Bug 10733 - grep -P looks broken wrt pipes
: grep -P looks broken wrt pipes
Status: CLOSED FIXED
: Sisyphus
(All bugs in Sisyphus/grep)
: unstable
: all Linux
: P2 normal
Assigned To:
:
:
:
:
:
  Show dependency tree
 
Reported: 2007-01-30 00:12 by
Modified: 2010-09-20 21:46 (History)


Attachments


Note

You need to log in before you can comment on or make changes to this bug.


Description From 2007-01-30 00:12:20
$ rpm -qa --qf '[%{PROVIDES}\n]' |grep -Po '^lib[^/()]+[.]so\b[^/()]*'
outputs lines that match the soname pattern as well as lines that do not match
the pattern; and even empty lines which are not in the input.

http://lists.altlinux.org/pipermail/devel/2007-January/041110.html
------- Comment #1 From 2007-04-15 00:54:47 -------
grep -P is also utterly broken, besides of -o option:

$ for i in `seq 1 999`; do rpm -qa --qf '[%{PROVIDES}\n]' |grep -P
'^lib[^/()]+\.so' |grep -vc ^lib; done |sort |uniq -c |sort -n
      3 2
     62 3
    934 1

Thats is, looks like grep -P returns semi-random wrong results.
------- Comment #2 From 2007-09-19 05:09:57 -------
Something odd happens with pipes: replacing
rpmquery -a --qf '[%{PROVIDES}\n]'
with
cat file
makes grep -Po happy.
------- Comment #3 From 2010-09-20 21:46:52 -------
In grep-2.6.3-alt1 the bug is already fixed.